<?
header('Content-Type: text/plain; charset=utf-8');

if(!isset($_REQUEST['Action']))
	ReturnMessage('EAction not specified');

require_once('../Config.php');
require_once('../Lib/SQL.php');

switch($_REQUEST['Action'])
{
	case 'GetUpdates': //Get the list of updates since the last update
		//Query for the data
		$QueryTime=time();
		if(!isset($_REQUEST['LastUpdate']) || !preg_match('/^\d{1,10}$/D', $_REQUEST['LastUpdate']))
			ReturnMessage('ELast update time not specified');
		$AKs=GetAccessKeys();
		$Query=MysqlQuery('SELECT UserID, Latitude, Longitude, Altitude, Accuracy, RealTime FROM Users WHERE RealTime>=? AND AccessKey In ('.MysqlPrepareList($AKs).')', $_REQUEST['LastUpdate'], $AKs);

		//Return in format "S"+QueryTime+";"+NumUpdates+((";"+UserID+";"+Latitude+";"+Longitude+";"+Accuracy+";"+RealTime)+...)
		$QueryResults=Array();
		foreach(MysqlFetchData($Query) as $Data)
			array_push($QueryResults, implode(';', $Data));
		array_unshift($QueryResults, "S$QueryTime", count($QueryResults));
		print implode(';', $QueryResults);
		break;
	case 'GetUsersInfo': //Get all the user's information
		$AKs=GetAccessKeys();
		$UsersInfo=Array();
		foreach(MysqlFetchData(MysqlQuery('SELECT UserID, UserName, AccessKey FROM Users WHERE AccessKey IN ('.MysqlPrepareList($AKs).')', $AKs)) as $UserInfo)
			$UsersInfo[]=implode(';', $UserInfo);
		print "S".implode(',', $UsersInfo);
		break;
	default:
		ReturnMessage('EInvalid Action');
}

function ReturnMessage($Msg)
{
	print $Msg;
	exit();
}

//Check and return the access keys
function GetAccessKeys()
{
	global $MaxAccessKeys;
	if(!isset($_REQUEST['AccessKeys']))
		ReturnMessage('EAccess keys not provided');
	else if(!preg_match('/^[A-Za-z0-9]{6}(,[A-Za-z0-9]{6})*$/D', $_REQUEST['AccessKeys']))
		ReturnMessage('EInvalid access keys');
	$AKs=explode(',', $_REQUEST['AccessKeys']);
	if(count($AKs)>$MaxAccessKeys)
		ReturnMessage('ECannot access more than '.$MaxAccessKeys.' users at once');
	return array_unique($AKs);
}
?>